/* interface.c
 * Copyright (C) 2004, 2005 Sylvain Cresto <sylvain.cresto@tiscali.fr>
 * 
 * This file is part of graveman!
 *
 * graveman! is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or
 * (at your option) any later version.
 * 
 * graveman! is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with program; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA. 
 * 
 * URL: http://scresto.site.voite.fr/
 *
 */

/* definition des fenetres */

#include "graveman.h"
/* drag and drop */
GtkTargetEntry Gdndaudio[] = { { "dndaudio", GTK_TARGET_SAME_WIDGET, 0},
                               {"text/plain", 0, 1},
                               {"application/x-desktop", 0, 2 }};
GtkTargetEntry Gdnddata[] = {  { "dnddata", GTK_TARGET_SAME_WIDGET, 0},
                               {"text/plain", 0, 1},
                               {"application/x-desktop", 0, 2 }};

/* liste des medias */
GSList *Gmedialist = NULL;

#if 0
Tmediaentry Gdefaultmedia[] = {
  { 665600, N_("74 min"), N_("650 mb") },
  { 716800, N_("80 min"), N_("700 mb") },
  { 808960, N_("90 min"), N_("790 mb") },
  { 889856, N_("99 min"), N_("869 mb") },
  { 899072, N_("100 min"), N_("878 mb") },
  { 0, "", "" },
};
#endif

Tmyentry Gtypecdaudio[] = {
  { "1260", N_("21 min"), FALSE },
  { "1380", N_("23 min"), FALSE },
  { "4440", N_("74 min"), FALSE },
  { "4800", N_("80 min"), TRUE },
  { "5400", N_("90 min"), FALSE },
  { "5940", N_("99 min"), FALSE },
  { "6000", N_("100 min"), FALSE },
  { NULL }
};

Tmyentry Gtypecddata[] = {
  { "180", N_("180 mb"), FALSE },
  { "202", N_("202 mb"), FALSE },
  { "650", N_("650 mb"), FALSE },
  { "700", N_("700 mb"), TRUE  },
  { "790", N_("790 mb"), FALSE },
  { "869", N_("869 mb"), FALSE },
  { "878", N_("878 mb"), FALSE },
  { NULL }
};

Tmyentry Gtypeunit[] = {
  { "kb", N_("kb"), TRUE },
  { "mb", N_("mb"), FALSE },
  { "gb", N_("gb"), FALSE },
};

Tmyentry Gmodburn[] = {
    { "dao", N_("Disk At Once - DAO (default)"), TRUE },
    { "tao", N_("Track At Once  - TAO"), FALSE },
    { "raw96r", N_("RAW writing - raw96r"), FALSE },
    { "raw96", N_("RAW writing - raw96"), FALSE },
    { "raw96p", N_("RAW writing - raw96p"), FALSE },
    { NULL }
  };

Tmyentry Gisolevel[] = {
  { "1", N_("ISO 9660 level 1"), FALSE },
  { "2", N_("ISO 9660 level 2 (default)"), TRUE },
  { "3", N_("ISO 9660 level 3"), FALSE },
  { NULL }
};

Tmyentry Gformatcd[] = {
    { "mode1", N_("CD-Rom Mode 1 (default)"), TRUE},
    { "mode2", N_("CD-Rom Mode 2"), FALSE },
    { "xa1", N_("CD-Rom XA Mode 1"), FALSE },
    { "xa2", N_("CD-Rom XA Mode 2"), FALSE },
    { NULL }
  };

GdkPixbuf *GDirIcone, *GFileIcone, *GCDIcone, *GAudioIcone, *GCDRWIcone, *GCDpetiteIcone,
  *GCDRWpetiteIcone, *GpetiteGraver, *GGraver, *GISOpetiteIcone, *GEraseCdrw, *GFileImage;

void remplirecombovitesse(GtkComboBox *Acombo, gchar *Alecident)
{
  GtkListStore *Ldata = GTK_LIST_STORE(gtk_combo_box_get_model(Acombo));
  gchar *Llabel, *Lident;  
  gint i;
  gint passe = 0;
  GtkTreeIter Liter;
  gint Ldef = 0;
  gboolean Lactive = FALSE;
  gint Lmaxspeed = MAX_SPEED;
  const gchar *Ldefspeed = g_getenv("CDR_SPEED");

  if (Ldefspeed && *Ldefspeed) Ldef = atoi(Ldefspeed);

  if (Alecident && *Alecident) {
    Tdrive_info *Lundrive = findlecteur(Alecident);

    Lmaxspeed = Lundrive->vitesse;

  }

  gtk_list_store_clear(Ldata);

  for (i=1; 1; i++) {
    passe = ! passe;
    if (passe) continue;
    Llabel = g_strdup_printf("%dx", i);
    Lident = g_strdup_printf("%d", i);    
    gtk_list_store_append(Ldata, &Liter);
    gtk_list_store_set(Ldata, &Liter, 0, Lident, 1, Llabel, -1);
    if (Ldef == i) { gtk_combo_box_set_active_iter(Acombo, &Liter); Lactive = TRUE; }
    g_free(Llabel); g_free(Lident);
    
    if (i >= Lmaxspeed) break;
  }

  gtk_list_store_append(Ldata, &Liter);
  gtk_list_store_set(Ldata, &Liter, 0, "0", 1, _("Full speed"), -1);
  if (Lactive == FALSE) gtk_combo_box_set_active_iter(Acombo, &Liter);
}

void remplirecombo (GtkComboBox *Acombo, gchar *Abasename, Tmyentry *Aentry, gboolean Adoinit)
{
  GtkListStore *Ldata;
  gchar *Lident;
  Tmyentry *Lcurentry;
  GtkTreeIter Liter;

  if (Adoinit == FALSE) {
    Ldata = GTK_LIST_STORE(gtk_combo_box_get_model(Acombo));
  } else {
    GtkCellRenderer *Lcellrender;

    Ldata = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);  
    gtk_combo_box_set_model(Acombo, GTK_TREE_MODEL(Ldata));

    gtk_cell_layout_clear(GTK_CELL_LAYOUT(Acombo));
    Lcellrender = GTK_CELL_RENDERER(gtk_cell_renderer_text_new());
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(Acombo), Lcellrender, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(Acombo), Lcellrender,
      "text", 1, NULL);
  }

  gtk_list_store_clear(Ldata);
  
  for (Lcurentry = Aentry; Lcurentry->label; Lcurentry++) {
    Lident = g_strdup_printf("%s%s", Abasename, Lcurentry->basecode);
    gtk_list_store_append(Ldata, &Liter);
    gtk_list_store_set(Ldata, &Liter, 0, Lident, 1, Lcurentry->label, -1); 
    g_free(Lident);
    if (Lcurentry->defaut == TRUE) gtk_combo_box_set_active_iter(Acombo, &Liter);
  }
}

void remplirecombograveur(GtkComboBox *Acombo, gint Aquoi)
{
  GtkListStore *Ldata = GTK_LIST_STORE(gtk_combo_box_get_model(Acombo));
  gint i;
  gboolean Lpremier = FALSE;
  GtkTreeIter Liter;

  gtk_list_store_clear(Ldata);
  
  for (i=0; i < Gnumdrives; i++) {
    if ((Aquoi & GRAVEUR_ONLY) && (! DRIVE_WRITER(i))) continue;
    
    gtk_list_store_append(Ldata, &Liter);

    gtk_list_store_set(Ldata, &Liter, 0, Gldrives[i].dev, 1, 
      DRIVE_ICONE(i), 2, Gldrives[i].name, 3, i, -1);
    
    if (Lpremier == FALSE) {      
      Lpremier = TRUE;
      gtk_combo_box_set_active_iter(Acombo, &Liter);
    }
  }
  
  if (Aquoi & ISO) {    
    gtk_list_store_append(Ldata, &Liter);
    gtk_list_store_set(Ldata, &Liter, 0, "iso", 1, GISOpetiteIcone, 2, _("ISO file..."), 3, 0, -1);
  }  
}

void remplirelistegraveur(GtkTreeView *Aliste)
{
  GtkListStore *Ldata = GTK_LIST_STORE(gtk_tree_view_get_model(Aliste));
  GtkTreeIter Liter;
  gint i;

  gtk_list_store_clear(Ldata);
  
  for (i=0; i < Gnumdrives; i++) {
    gtk_list_store_append(Ldata, &Liter);
    gtk_list_store_set(Ldata, &Liter, 0, i, 1, DRIVE_ICONE(i), 2, Gldrives[i].dev, 3, 
          DRIVE_WRITER(i) ? _("CD Recorder") : _("CD Reader"), 4, Gldrives[i].name, -1);
  }
}

#if 0
void remplirelistemedia(GtkTreeView *Aliste)
{
  GtkListStore *Ldata = GTK_LIST_STORE(gtk_tree_view_get_model(Aliste));
  GtkTreeIter Liter;
  GSList *Lcur;
  Tmediaentry *Lcurmedia;

  gtk_list_store_clear(Ldata);

  for (Lcur = Gmedialist; Lcur; Lcur = g_slist_next(Lcur)) {
    Lcurmedia = (Tmediaentry *)Lcur->data;
    gtk_list_store_append(Ldata, &Liter);
    gtk_list_store_set(Ldata, &Liter, 0, Lcurmedia->labeldata, 1, Lcurmedia->labelaudio, -1);
  }
}
#endif
/* menu popup sur les pistes audio */
GtkMenu *create_gtkpopupmenuaudio(GtkWidget *Aliste, GHashTable *Ahash)
{
  GtkMenu *Lmenu = GTK_MENU(g_hash_table_lookup(Ahash, "popupaudio"));
  GtkTreeModel *Lmodel = gtk_tree_view_get_model(GTK_TREE_VIEW(Aliste));
  GtkTreeIter Liter;
  GtkWidget *Litem;
  GtkTreePath *Lpath = NULL;

  /* on cherche l'object selectionne, on est pas sur qu'il y en ai un car
   * on est en SELECTION_MULTIPLE */
  gtk_tree_view_get_cursor(GTK_TREE_VIEW(Aliste), &Lpath, NULL);

  Litem = GTK_WIDGET(g_hash_table_lookup(Ahash, "popupaudio_removetrack"));
  if (Lpath && gtk_tree_model_get_iter(Lmodel, &Liter, Lpath)) {
    gtk_widget_set_sensitive(Litem, TRUE);
  } else {
    gtk_widget_set_sensitive(Litem, FALSE);
  }

  if (Lpath) gtk_tree_path_free(Lpath);
   
  return Lmenu;
}

GtkMenu *create_gtkpopupmenudata(GtkWidget *Aliste, GHashTable *Ahash)
{
  GtkMenu *Lmenu = GTK_MENU(g_hash_table_lookup(Ahash, "popupdata"));
  GtkTreeModel *Lmodel = gtk_tree_view_get_model(GTK_TREE_VIEW(Aliste));
  GtkWidget *Litem, *Litem2, *Lsep;
  GtkTreeSelection *Lselection = gtk_tree_view_get_selection(GTK_TREE_VIEW(Aliste));
  GtkTreeIter Liter;
  gint type;
  gint Lnumsel = gtk_tree_selection_count_selected_rows(Lselection);
  gboolean Lonlyone = TRUE;
  GtkTreePath *Lpath = NULL;

  /* on cherche l'object selectionne, il peu y en avoir plusieur
   * car on est en SELECTION_MULTIPLE */

  /* focus sur le premier element si pas de focus */
  if (!Lnumsel) {
    if (!gtk_tree_model_get_iter_first(Lmodel, &Liter)) return NULL;

    gtk_tree_selection_select_iter(Lselection, &Liter);
    gtk_widget_grab_focus(Aliste);
  } else {
    /* si plusieurs elements de selectionne alors on pointe sur celui etant
     * sous le curseur */
    gtk_tree_view_get_cursor(GTK_TREE_VIEW(Aliste), &Lpath, NULL);
    if (!Lpath) {
      gtk_widget_grab_focus(Aliste);
      gtk_tree_view_get_cursor(GTK_TREE_VIEW(Aliste), &Lpath, NULL);
      if (!Lpath) return NULL;
    }
    gtk_tree_model_get_iter(Lmodel, &Liter, Lpath);
    gtk_tree_path_free(Lpath);

    Lonlyone = (Lnumsel == 1 ? TRUE : FALSE);
  }

  
  /* type nous permet de savoir le type de ligne selectionne (CD, DIR, FILE...) */
  gtk_tree_model_get(Lmodel, &Liter, 0, &type, -1);

  /* RENOMMER LE CD */
  Litem = g_hash_table_lookup(Ahash, "popupdata_renamecd");
  if (type == TYPE_CD && Lonlyone) {
    gtk_widget_show(Litem);
  } else {
    gtk_widget_hide(Litem);
  }

  /* EXPAND */
  Litem = g_hash_table_lookup(Ahash, "popupdata_expand");
  if (type != TYPE_FILE && Lonlyone) {
    gtk_widget_show (Litem);
  } else {
    gtk_widget_hide(Litem);
  }

  /* RENOMMER L'ELEMENT SELECTIONNE */
  Litem = g_hash_table_lookup(Ahash, "popupdata_renamedirectory");
  if (type == TYPE_DIR && Lonlyone) {
    gtk_widget_show (Litem);
  } else {
    gtk_widget_hide (Litem);
  }
  Litem = g_hash_table_lookup(Ahash, "popupdata_renamefile");
  if (type == TYPE_FILE && Lonlyone) {
    gtk_widget_show (Litem);
  } else {
    gtk_widget_hide (Litem);
  }

  /* CREER UN REPERTOIRE */
  Litem = g_hash_table_lookup(Ahash, "popupdata_createdirectory");
  if (type != TYPE_FILE && Lonlyone) {
    gtk_widget_show (Litem);
  } else {
    gtk_widget_hide (Litem);
  }

  /* AJOUTER DES FICHIERS */
  /* AJOUTER DES REPERTOIRES */
  Lsep = g_hash_table_lookup(Ahash, "popupdata_sep1");
  Litem = g_hash_table_lookup(Ahash, "popupdata_addfile");
  Litem2 = g_hash_table_lookup(Ahash, "popupdata_adddirectory");
  if (type != TYPE_FILE && Lonlyone) {
    gtk_widget_show (Lsep);
    gtk_widget_show (Litem);
    gtk_widget_show (Litem2);
  } else {
    gtk_widget_hide (Lsep);
    gtk_widget_hide (Litem);
    gtk_widget_hide (Litem2);
  }

  /* SUPPRIMER DE LA LISTE */
  Lsep = g_hash_table_lookup(Ahash, "popupdata_sep2");
  Litem = g_hash_table_lookup(Ahash, "popupdata_remove");
  if (type != TYPE_CD) {
    if (Lonlyone) {
      gtk_widget_show (Lsep);
    } else {
      gtk_widget_hide (Lsep);
    }
    gtk_widget_set_sensitive(Litem, TRUE);
    gtk_widget_show (Litem);

    /* suppresion des fichiers */
  } else {
    gtk_widget_hide (Lsep);
    if (Lonlyone) {
      gtk_widget_hide (Litem);
    } else {
      /* si plusieurs elements de selectionne mais que le focus
       * est sur le CD alors on affiche quand meme l'action "suppresion
       * des fichiers" dans le popup en la grisant pour que le popup
       * ne soit pas entierement vide */
      gtk_widget_set_sensitive(Litem, FALSE);
      gtk_widget_show (Litem);
    }
  }

  /* IMAGE DE BOOT */
/*  Lsep = g_hash_table_lookup(Ahash, "popupdata_sep3");
  Litem = g_hash_table_lookup(Ahash, "popupdata_imageboot");
  if (type == TYPE_FILE) {
    gtk_widget_show (Lsep);
    gtk_widget_show (Litem);

  } else {
    gtk_widget_hide (Lsep);
    gtk_widget_hide (Litem);
  }*/

  return Lmenu;
}

void prepare_popups(GladeXML *Axml, GHashTable *Ahash)
{
  /* popup cd audio */
  glade_to_hash(Axml, Ahash, "popupaudio");
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupaudio_addtrack")),
      "activate", G_CALLBACK(gtk_audio_addtrack), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupaudio_removetrack")),
      "activate", G_CALLBACK(gtk_audio_removetrack), Ahash);

  /* popup cd data */
  glade_to_hash(Axml, Ahash, "popupdata");
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_renamecd")),
      "activate", G_CALLBACK(gtk_data_renommerelement), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_expand")),
      "activate", G_CALLBACK(gtk_data_expandelement), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_renamefile")),
      "activate", G_CALLBACK(gtk_data_renommerelement), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_renamedirectory")),
      "activate", G_CALLBACK(gtk_data_renommerelement), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_createdirectory")),
      "activate", G_CALLBACK(gtk_data_creerrepertoire), Ahash);
  glade_to_hash(Axml, Ahash, "popupdata_sep1");
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_addfile")),
      "activate", G_CALLBACK(gtk_data_addfile), Ahash);
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_adddirectory")),
      "activate", G_CALLBACK(gtk_data_adddirectory), Ahash);

  glade_to_hash(Axml, Ahash, "popupdata_sep2");
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_remove")),
      "activate", G_CALLBACK(gtk_data_removefiles), Ahash);

#if 0
  glade_to_hash(Axml, Ahash, "popupdata_sep3");
  g_signal_connect(G_OBJECT(glade_to_hash(Axml, Ahash, "popupdata_imageboot")),
      "activate", G_CALLBACK(gtk_def_imageboot), Ahash);
#endif

}

GtkAlignment *new_seliso(gchar *Aname, GtkWidget *Aparent)
{
  GtkHBox *Lnewhbox = GTK_HBOX(gtk_hbox_new (FALSE, 3));
  GtkAlignment *Lnewboxalignement = GTK_ALIGNMENT(gtk_alignment_new (1, 0.5, 0, 0));
  GtkHBox *Lbtnbox = GTK_HBOX(gtk_hbox_new (FALSE, 2));
  GtkEntry *Lisoname = GTK_ENTRY(gtk_entry_new());
  GtkButton *Lbutton = GTK_BUTTON(gtk_button_new());
  GtkAlignment *Lalignement = GTK_ALIGNMENT(gtk_alignment_new (0.5, 0.5, 0, 0));
  GtkImage *Lbuttonimg;
  GtkLabel *Lbuttonlbl;
  gchar *Lentryname;

  gtk_widget_show (GTK_WIDGET(Lnewhbox));
  gtk_widget_show (GTK_WIDGET(Lbutton));
  gtk_widget_show (GTK_WIDGET(Lisoname));
  
  gtk_widget_show (GTK_WIDGET(Lalignement));
  gtk_container_add(GTK_CONTAINER(Lbutton), GTK_WIDGET(Lalignement));
  
  gtk_widget_show (GTK_WIDGET(Lbtnbox));
  gtk_container_add (GTK_CONTAINER (Lalignement), GTK_WIDGET(Lbtnbox));
  
  Lbuttonimg = GTK_IMAGE(gtk_image_new_from_stock("gtk-jump-to", GTK_ICON_SIZE_BUTTON));
  gtk_widget_show (GTK_WIDGET(Lbuttonimg));
  gtk_box_pack_start (GTK_BOX(Lbtnbox), GTK_WIDGET(Lbuttonimg), FALSE, FALSE, 0);
  Lbuttonlbl = GTK_LABEL(gtk_label_new_with_mnemonic (_("O_pen")));

  gtk_widget_show(GTK_WIDGET(Lbuttonlbl));
  gtk_box_pack_start (GTK_BOX(Lbtnbox), GTK_WIDGET(Lbuttonlbl), FALSE, FALSE, 0);

  gtk_container_add (GTK_CONTAINER (Lnewhbox), GTK_WIDGET(Lisoname));
  gtk_container_add (GTK_CONTAINER (Lnewhbox), GTK_WIDGET(Lbutton));

  gtk_container_add(GTK_CONTAINER(Lnewboxalignement), GTK_WIDGET(Lnewhbox));

  gtk_widget_set_name(GTK_WIDGET(Lbutton), Aname);
  g_signal_connect(G_OBJECT(Lbutton), "clicked", G_CALLBACK(gtk_file_sel), Lisoname);

  Lentryname = g_strdup_printf("%svalue", Aname);
  GLADE_HOOKUP_OBJECT(Aparent, GTK_WIDGET(Lisoname), Lentryname);
  g_free(Lentryname);

  return Lnewboxalignement;
}

/* fenetre principal */
GtkWidget* manage_main_window (guint32 *Aaudiolen, guint32 *Aaudiomaxlen,
    guint32 *Adatasize, guint32 *Adatamaxsize)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/window_main.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkWidget *Lwindow;
  GtkNotebook *Lbodycdaudio, *Lbodycddata, *Lbodycdcopy, *Lbodycdother;
  GtkHBox *Lmainbody;
  GtkToggleButton *Ltogbtnaudio, *Ltogbtncopy, *Ltogbtnother, *Ltogbtndata;
  GtkComboBox *Lcombo;
  GtkButton *Lbtnerasecdrw;
  GtkTreeView *Ltreeaudio, *Ltreedata;
  GHashTable *Lhash = _hash();

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  Lmainbody = GTK_HBOX(glade_xml_get_widget(Lxml, "mainbody"));
  Lwindow = GTK_WIDGET(glade_to_hash(Lxml, Lhash, "topwindow"));
  g_hash_table_insert(Lhash, "window", Lwindow);
  g_hash_table_insert(Lhash, "audiolen", Aaudiolen);
  g_hash_table_insert(Lhash, "audiomaxlen", Aaudiomaxlen);
  g_hash_table_insert(Lhash, "datasize", Adatasize);
  g_hash_table_insert(Lhash, "datamaxsize", Adatamaxsize);

  /* onglets page de droite */
  Lbodycdaudio = GTK_NOTEBOOK(glade_to_hash(Lxml, Lhash, "bodycdaudio"));
  gtk_widget_reparent(GTK_WIDGET(Lbodycdaudio), GTK_WIDGET(Lmainbody));
  Lbodycddata = GTK_NOTEBOOK(glade_to_hash(Lxml, Lhash, "bodycddata"));
  gtk_widget_reparent(GTK_WIDGET(Lbodycddata), GTK_WIDGET(Lmainbody));
  Lbodycdcopy = GTK_NOTEBOOK(glade_to_hash(Lxml, Lhash, "bodycdcopy"));
  gtk_widget_reparent(GTK_WIDGET(Lbodycdcopy), GTK_WIDGET(Lmainbody));
  Lbodycdother = GTK_NOTEBOOK(glade_to_hash(Lxml, Lhash, "bodycdother"));
  gtk_widget_reparent(GTK_WIDGET(Lbodycdother), GTK_WIDGET(Lmainbody));

  /* mise a jour des label lorsque l'on change d'onglet dans la partie "graver un cd de donnee" */
  g_signal_connect(G_OBJECT(Lbodycddata), "switch-page", G_CALLBACK(switchpage), Lhash);

  /* bouttons barre de gauche */
  Ltogbtndata = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "btncddata"));
  g_signal_connect(G_OBJECT(Ltogbtndata), "toggled", G_CALLBACK(changemenu), Lhash);
  Ltogbtncopy = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "btncdcopy"));
  g_signal_connect(G_OBJECT(Ltogbtncopy), "toggled", G_CALLBACK(changemenu), Lhash);
  Ltogbtnother = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "btncdother"));
  g_signal_connect(G_OBJECT(Ltogbtnother), "toggled", G_CALLBACK(changemenu), Lhash);
  Ltogbtnaudio = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "btncdaudio"));
  g_signal_connect(G_OBJECT(Ltogbtnaudio), "toggled", G_CALLBACK(changemenu), Lhash);

  /* activation onglet "cd audio" par defaut */
  gtk_toggle_button_set_active(Ltogbtnaudio, TRUE);

  /* signaux sur le menu */
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menustartnew")), "activate",
      G_CALLBACK(menu_start_new), Lhash);

  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menucdaudio")), "activate",
      G_CALLBACK(menu_active_panel), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menucddata")), "activate",
      G_CALLBACK(menu_active_panel), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menucdcopy")), "activate",
      G_CALLBACK(menu_active_panel), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menucdother")), "activate",
      G_CALLBACK(menu_active_panel), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menuproperties")), "activate",
      G_CALLBACK(menu_active_proprietes), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menuquit")), "activate",
      G_CALLBACK(menu_quit), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "menuabout")), "activate",
      G_CALLBACK(on_about), Lhash);

  
  prepare_combobox_vitesse(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "dstaudiospeed")));
  glade_to_hash(Lxml, Lhash, "srccopytable");
  prepare_combobox_vitesse(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "dstcopyspeed")));
  glade_to_hash(Lxml, Lhash, "dstcopytable");
  prepare_combobox_vitesse(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "dstdataspeed")));
  glade_to_hash(Lxml, Lhash, "dstdatatable");

  /* onglet graver un cd audio */
  glade_to_hash_list(Lxml, Lhash, "audiosimul", "audionotfix", "nbrcdaudio", NULL);

  /* onglet graver un cd de donnee */
  glade_to_hash_list(Lxml, Lhash, "datavoli", "datapubl", "dataprep", "databibl", "datacopy", "dataabst",
      "datarockridge", "datajoliet", NULL);
  glade_to_hash_list(Lxml, Lhash, "nbrcddata", "datamulti", "datanotfix", "datasimul", NULL);
  
  /* onglet copier un cd */
  glade_to_hash_list(Lxml, Lhash, "nbrcdcopy", "copysimul", NULL);

  /* tous les combo contenant la liste des lecteurs */
  prepare_combobox_graveur(Lxml, Lhash, "dstaudio");
  
  prepare_combobox_graveur(Lxml, Lhash, "dstdata");
  prepare_disable_when_iso(Lhash, "dstdatacombo", "nbrcddata", "datamulti", "datanotfix", "datasimul", NULL);

  prepare_combobox_graveur(Lxml, Lhash, "srccopy");
  prepare_combobox_graveur(Lxml, Lhash, "dstcopy");
  prepare_disable_when_iso(Lhash, "dstcopycombo", "nbrcdcopy", "copysimul", NULL);

  Lbtnerasecdrw = GTK_BUTTON(glade_to_hash(Lxml, Lhash, "btnerasecdrwother1"));
  prepare_combobox_graveur(Lxml, Lhash, "dstother");
  prepare_disable_when_notcdrw(Lhash, "dstothercombo", "btnerasecdrwother1", NULL);

  
  update_combo_graveur(Lhash);


  /* on rempli les autres combo */
  remplirecombo(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "dataformat")), "", Gformatcd, TRUE);
  remplirecombo(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "datamodburn")), "", Gmodburn, TRUE);
  remplirecombo(GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "dataisolevel")), "", Gisolevel, TRUE);
  Lcombo = GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "listeremplidata"));
  remplirecombo(Lcombo, "", Gtypecddata, TRUE); 
  g_signal_connect(G_OBJECT(Lcombo), "changed", G_CALLBACK(change_remplissage), Lhash);

  Lcombo = GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "listerempliaudio"));
  remplirecombo(Lcombo, "", Gtypecdaudio, TRUE);
  g_signal_connect(G_OBJECT(Lcombo), "changed", G_CALLBACK(change_remplissage), Lhash);
 
  /* boutons "page suivante" */
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnnextaudio1")), "clicked", G_CALLBACK(gonextpage), Lbodycdaudio);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnnextdata1")), "clicked", G_CALLBACK(gonextpage), Lbodycddata);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnnextdata2")), "clicked", G_CALLBACK(gonextpage), Lbodycddata);

  /* boutons "graver" */
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnburnaudio2")), "clicked", G_CALLBACK(confirm_burn), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnburndata2")), "clicked", G_CALLBACK(confirm_burn), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnburndata3")), "clicked", G_CALLBACK(confirm_burn), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnburncopy1")), "clicked", G_CALLBACK(confirm_burn), Lhash);

  /* boutons de la page "autres operations" */
  g_signal_connect(G_OBJECT(Lbtnerasecdrw), "clicked", G_CALLBACK(confirm_erasecdrw), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnfixcdother1")), "clicked", G_CALLBACK(confirm_fixcd), Lhash);
  
  
  /* menu popup sur les listes */
  glade_to_hash_list(Lxml, Lhash, "audiolenbar", "datasizebar", NULL);
  Ltreeaudio = GTK_TREE_VIEW(glade_to_hash(Lxml, Lhash, "LISTEAUDIO"));
  prepare_popups(Lxml, Lhash);
  prepare_listeaudio(Ltreeaudio);
  g_signal_connect(G_OBJECT(Ltreeaudio), "button-press-event", G_CALLBACK(gtk_do_eventbuttonpress), Lhash);
  g_signal_connect(G_OBJECT(Ltreeaudio), "popup-menu", G_CALLBACK(view_popupmenu_addaudio), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnaddtrack")), "clicked", G_CALLBACK(gtk_audio_addtrack), Lhash);

  Ltreedata = GTK_TREE_VIEW(glade_to_hash(Lxml, Lhash, "LISTEDATA"));
  prepare_listedata(Ltreedata);
  g_signal_connect(G_OBJECT(Ltreedata), "button-press-event", G_CALLBACK(gtk_do_eventbuttonpress), Lhash);
  g_signal_connect(G_OBJECT(Ltreedata), "popup-menu", G_CALLBACK(view_popupmenu_addfile), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnaddfile")), "clicked", G_CALLBACK(gtk_data_addfile), Lhash);
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btnadddirectory")), "clicked",
      G_CALLBACK(gtk_data_adddirectory), Lhash);


  /* drag and drop */
  gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (Ltreeaudio),
           GDK_BUTTON1_MASK, Gdndaudio, G_N_ELEMENTS (Gdndaudio), GDK_ACTION_MOVE|GDK_ACTION_COPY);
  gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (Ltreeaudio),
               Gdndaudio, G_N_ELEMENTS (Gdndaudio), GDK_ACTION_MOVE|GDK_ACTION_COPY);
  g_signal_connect(G_OBJECT(Ltreeaudio), "drag-data-received", G_CALLBACK(audio_dnd_data_received), Lhash);
//    g_signal_connect(G_OBJECT(Ltreeaudio), "drag_data_received", G_CALLBACK(audio_dnd_data_received),
  //    Lhash);

/*
  gtk_drag_dest_set(GTK_WIDGET(Ltreedata),
      GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | GTK_DEST_DEFAULT_DROP, Gdnddata,
      G_N_ELEMENTS(Gdnddata), GDK_ACTION_COPY | GDK_ACTION_MOVE);
  g_signal_connect(G_OBJECT(Ltreedata), "drag_data_received", G_CALLBACK(data_dnd_data_received),
      Lhash);*/
  gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (Ltreedata),
           GDK_BUTTON1_MASK, Gdnddata, G_N_ELEMENTS (Gdnddata), GDK_ACTION_MOVE|GDK_ACTION_COPY);
  gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (Ltreedata),
           Gdnddata, G_N_ELEMENTS (Gdnddata), GDK_ACTION_MOVE|GDK_ACTION_COPY);
  g_signal_connect(G_OBJECT(Ltreedata), "drag-data-received", G_CALLBACK(data_dnd_data_received),
      Lhash);

  g_signal_connect(G_OBJECT(Lwindow), "delete_event", G_CALLBACK(delete_event_quit), Lhash);

  /* on restaure la taille et la position que la fenetre avait lors de la derniere utilisation */ 
  restore_main_window_pos(Lwindow); 

  gtk_widget_show(Lwindow);

  return Lwindow;
}

/* mise a jour des listes contenant les lecteurs */
void update_combo_graveur(GHashTable *Ahash)
{
  GtkComboBox *Lsrccopycombo = GTK_COMBO_BOX(g_hash_table_lookup(Ahash, "srccopycombo"));
  GtkComboBox *Ldstcopycombo = GTK_COMBO_BOX(g_hash_table_lookup(Ahash, "dstcopycombo"));
  GtkComboBox *Ldstdatacombo = GTK_COMBO_BOX(g_hash_table_lookup(Ahash, "dstdatacombo"));
  GtkComboBox *Ldstaudiocombo = GTK_COMBO_BOX(g_hash_table_lookup(Ahash, "dstaudiocombo"));
  GtkComboBox *Ldstothercombo = GTK_COMBO_BOX(g_hash_table_lookup(Ahash, "dstothercombo"));
  
  remplirecombograveur(Lsrccopycombo, ALL + ISO);
  on_selectgraveur(GTK_WIDGET(Lsrccopycombo), Ahash);
  
  remplirecombograveur(Ldstcopycombo, GRAVEUR_ONLY + ISO);
  on_selectgraveur(GTK_WIDGET(Ldstcopycombo), Ahash);
  
  remplirecombograveur(Ldstdatacombo, GRAVEUR_ONLY + ISO);
  on_selectgraveur(GTK_WIDGET(Ldstdatacombo), Ahash);
  
  remplirecombograveur(Ldstaudiocombo, GRAVEUR_ONLY);
  on_selectgraveur(GTK_WIDGET(Ldstaudiocombo), Ahash);

  remplirecombograveur(Ldstothercombo, GRAVEUR_ONLY);
  on_selectgraveur(GTK_WIDGET(Ldstothercombo), Ahash);
}

GtkWidget* create_fileselection1 (GtkWindow *AParent, GtkFileChooserAction AType)
{
  GtkWidget *fileselection1;

  GtkFileFilter *filterall, *filteriso;

  /* filtres pour la selection de fichiers */
  filterall = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterall, _("All files (*.*)"));
  gtk_file_filter_add_pattern(filterall, "*");
  filteriso = gtk_file_filter_new ();
  gtk_file_filter_set_name (filteriso, _("Iso images only (*.iso)"));
  gtk_file_filter_add_pattern(filteriso, "*.iso");

  fileselection1 = gtk_file_chooser_dialog_new(AType == GTK_FILE_CHOOSER_ACTION_OPEN ? 
                                                _("Select iso image source") : _("Select iso image destination"),
                        AParent, AType, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				      NULL);

  gtk_dialog_set_default_response (GTK_DIALOG (fileselection1), GTK_RESPONSE_ACCEPT);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filteriso);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterall);

  return fileselection1;
}

GtkWidget* create_addfileselection (GtkWindow *AParent)
{
  GtkWidget *fileselection1;

  GtkFileFilter *filterall;

  /* filtres pour la selection de fichiers */
  filterall = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterall, _("All files (*.*)"));
  gtk_file_filter_add_pattern(filterall, "*");

  fileselection1 = gtk_file_chooser_dialog_new(_("Select iso image source"),
      AParent, GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);

  gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(fileselection1), TRUE);
  gtk_dialog_set_default_response (GTK_DIALOG (fileselection1), GTK_RESPONSE_ACCEPT);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterall);

  return fileselection1;
}

GtkWidget* create_addpisteselection (GtkWindow *AParent)
{
  GtkWidget *fileselection1;
  GtkFileFilter *filterall, *filterwav, *filteraudio;
#ifdef ENABLE_MP3
  GtkFileFilter *filtermp3;
#endif
#ifdef ENABLE_OGG
  GtkFileFilter *filterogg;
#endif

  /* filtres pour la selection de fichiers */
  filterall = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterall, _("All files (*.*)"));
  gtk_file_filter_add_pattern(filterall, "*");

  filteraudio = gtk_file_filter_new ();
  gtk_file_filter_set_name (filteraudio,
#if (defined ENABLE_MP3) && (defined ENABLE_OGG)
      _("All audio files (*.mp3 *.ogg *.wav)")
#elif defined ENABLE_MP3
      _("All audio files (*.mp3 *.wav)")
#elif defined ENABLE_OGG
      _("All audio files (*.ogg *.wav)")
#else
      _("All audio files (*.wav)")
#endif
  );

#ifdef ENABLE_MP3
  gtk_file_filter_add_pattern(filteraudio, "*.mp3");
  filtermp3 = gtk_file_filter_new ();
  gtk_file_filter_set_name (filtermp3, _("Mp3 files (*.mp3)"));
  gtk_file_filter_add_pattern(filtermp3, "*.mp3");
#endif
#ifdef ENABLE_OGG
  gtk_file_filter_add_pattern(filteraudio, "*.ogg");
  filterogg = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterogg, _("Ogg files (*.ogg)"));
  gtk_file_filter_add_pattern(filterogg, "*.ogg");
#endif
  gtk_file_filter_add_pattern(filteraudio, "*.wav");

  filterwav = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterwav, _("Wav files (*.wav)"));
  gtk_file_filter_add_pattern(filterwav, "*.wav");

  fileselection1 = gtk_file_chooser_dialog_new(_("Sectect an audio file to add"),
      AParent, GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);

  gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(fileselection1), TRUE);
  gtk_dialog_set_default_response (GTK_DIALOG (fileselection1), GTK_RESPONSE_ACCEPT);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filteraudio);
#ifdef ENABLE_MP3
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filtermp3);
#endif
#ifdef ENABLE_OGG
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterogg);
#endif  
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterwav);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterall);

  return fileselection1;
}

GtkWidget* create_adddirselection (GtkWindow *AParent)
{
  GtkWidget *fileselection1;
  GtkFileFilter *filterall;

  /* filtres pour la selection de fichiers */
  filterall = gtk_file_filter_new ();
  gtk_file_filter_set_name (filterall, _("All files (*.*)"));
  gtk_file_filter_add_pattern(filterall, "*");
  fileselection1 = gtk_file_chooser_dialog_new(_("Select a directory to add"),
      AParent, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);

  gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(fileselection1), TRUE);
  gtk_dialog_set_default_response (GTK_DIALOG (fileselection1), GTK_RESPONSE_ACCEPT);
  gtk_file_chooser_add_filter (GTK_FILE_CHOOSER (fileselection1), filterall);

  return fileselection1;
}

/* boite de dialogue "edition media" */
#if 0
GHashTable *addmediaformat(GHashTable *Aparent)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/dialog_media.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkWidget *Ldialog;
  GHashTable *Lhash = _hash();
  gulong Lsize = 0;
  GtkComboBox *Lcombo;

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }
  Ldialog = glade_to_hash(Lxml, Lhash, "dialog_media"); 

  g_hash_table_insert(Lhash, "fullsize", &Lsize);
  
  g_signal_connect(G_OBJECT(glade_to_hash(Lxml, Lhash, "mediadata")), "value-changed",
      G_CALLBACK(update_media_fields), Lhash);

  Lcombo = GTK_COMBO_BOX(glade_to_hash(Lxml, Lhash, "mediadataunit"));
  remplirecombo(Lcombo, "", Gtypeunit, TRUE);
  g_signal_connect(G_OBJECT(Lcombo), "changed", G_CALLBACK(update_media_unit), Lhash);

  glade_to_hash(Lxml, Lhash, "labelmediadata");
  glade_to_hash(Lxml, Lhash, "labelmediaaudio");

  return Lhash;
}
#endif

/* boite de dialogue "a propos de ..." */
void about_graveman (void)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/dialog_about.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkWidget *Ldialog;
  GtkLabel *Llabelversion;
  gchar *Ltmp;

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  Llabelversion = GTK_LABEL(glade_xml_get_widget(Lxml, "version"));

  Ltmp = g_strdup_printf(_("version %s"), VERSION);
  gtk_label_set_label(Llabelversion, Ltmp);
  g_free(Ltmp);

  Ldialog = glade_xml_get_widget(Lxml, "dialog_about"); 

  gtk_dialog_run(GTK_DIALOG(Ldialog));
  gtk_widget_destroy(Ldialog);

  g_free(Lxml);
}

/* fenetre copie d'un cd en cours */
void show_graverwindow (GHashTable *Ahash, gchar *Aaction, gchar *Atitle)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/window_burn.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkWidget *Lwindowburn;
  GtkLabel *Ltitle, *Lavancement;
  GtkProgressBar *Lpbtotal, *Lpbstep, *Lpbfifo, *Lpbbuffer;
  gint Ltotaldone = 0;
  gint Lpid = 0, Lpid2 = 0;
  gboolean Labort = FALSE;
  gboolean Lbackvalue = FALSE;
  GtkWidget *Lstatusbox = NULL;
  GError *Lerror = NULL;

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  Lwindowburn = glade_xml_get_widget(Lxml, "window_burn"); 

  /* titres avancement */
  Ltitle = GTK_LABEL(glade_to_hash(Lxml, Ahash, "gravetitle"));
  Lavancement = GTK_LABEL(glade_to_hash(Lxml, Ahash, "avancement"));
  
  /* barres de progression */
  Lpbtotal = GTK_PROGRESS_BAR(glade_to_hash(Lxml, Ahash, "pb_total"));
  Lpbstep = GTK_PROGRESS_BAR(glade_to_hash(Lxml, Ahash, "pb_step"));
  Lpbfifo = GTK_PROGRESS_BAR(glade_to_hash(Lxml, Ahash, "pb_fifo"));
  Lpbbuffer = GTK_PROGRESS_BAR(glade_to_hash(Lxml, Ahash, "pb_buffer"));

  /* on attache les variables utilisees lors de l'operation */
  g_hash_table_insert(Ahash, "totaldone", &Ltotaldone);
  g_hash_table_insert(Ahash, "gabort", &Labort);
  g_hash_table_insert(Ahash, "pid", &Lpid);
  g_hash_table_insert(Ahash, "pid2", &Lpid2);

  /* bouton annuler l'operation */
  g_signal_connect(G_OBJECT(glade_xml_get_widget(Lxml, "btncancelburn")), "clicked", G_CALLBACK(abort_gravure), Ahash);

  /* lancement de l'operation en elle meme */
  if (g_str_has_prefix(Aaction, "btnburncopy")) {
    Lbackvalue = burn_copy(Ahash, &Lerror);

  } else if (g_str_has_prefix(Aaction, "btnburnaudio")) {
    Lbackvalue = burn_audio(Ahash, &Lerror);
    /* Awindow1, Lwindow2, LprogressbarTotal, LprogressbarStep, LprogressbarFifo,
                            LprogressbarBuffer); */
  } else if (g_str_has_prefix(Aaction, "btnburndata")) {
    Lbackvalue = burn_data(Ahash, &Lerror);
  }

  if (Labort) {
    Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwindowburn),
                                     GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK,
                                     _("Operation aborted by user !"));
  } else {
    /* pour plus de beaute on s'assure que les barres de progression aient les bonnes
     * valeurs :-) */
    gtk_progress_bar_set_fraction(Lpbtotal, 1);
    gtk_progress_bar_set_fraction(Lpbstep, 1);
    gtk_progress_bar_set_fraction(Lpbfifo, 0);
    gtk_progress_bar_set_fraction(Lpbbuffer, 0);
    gtk_progress_bar_set_text(Lpbtotal, "100%");
    gtk_progress_bar_set_text(Lpbstep, "100%");
    gtk_progress_bar_set_text(Lpbfifo, "0%");
    gtk_progress_bar_set_text(Lpbbuffer, "0%");
    
    if (Lbackvalue == FALSE) {
      gtk_label_set_text(Ltitle, _("Operation failed"));
      
      Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwindowburn),
                      GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK,
                      Lerror->message);
    } else {
      gtk_label_set_text(Ltitle, _("Operation successful."));

      Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwindowburn),
                GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK,
                _("Operation successful"));
    }
  }

  if (Lstatusbox) {
    gtk_dialog_run(GTK_DIALOG(Lstatusbox));
    gtk_widget_destroy(Lstatusbox);
  }

  gtk_widget_destroy(Lwindowburn);
  if (Lerror) g_error_free(Lerror);
}
  
/* fenetre "operation en cours" */
GladeXML *create_window_encours(GtkWidget *Aparent)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/window_inprogress.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  if (GTK_IS_WIDGET(Aparent)) {
    GtkWidget *Lwin = glade_xml_get_widget(Lxml, "window_inprogress");
    gtk_window_set_transient_for(GTK_WINDOW(Lwin), GTK_WINDOW(Aparent));
  }

  return Lxml;
}

void prepare_combobox_vitesse(GtkComboBox *Acombobox)
{
  if (GTK_IS_WIDGET(Acombobox)) {
    GtkListStore *Lmodel = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);  
    GtkCellRenderer *Lcellrender = GTK_CELL_RENDERER(gtk_cell_renderer_text_new());
    gtk_combo_box_set_model(Acombobox, GTK_TREE_MODEL(Lmodel));
    
    gtk_cell_layout_clear(GTK_CELL_LAYOUT(Acombobox));
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(Acombobox), Lcellrender, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(Acombobox), Lcellrender,
      "text", 1, NULL);
  }
}

/* objets a cacher lorsque l'on selectionne une image iso en tant que source ou destination */
void prepare_disable_when_iso(GHashTable *Ahash, gchar *Abasename, const gchar *Afirst, ...)
{
  va_list Largs;
  gchar *Lbuf = (gchar *) Afirst;
  gint Lnbr = 0;
  gchar *Lname = g_strdup_printf("%s_isotodisabled%d", Abasename, Lnbr++);
  gchar *Lcur;

  g_hash_table_insert(Ahash, Lname, g_hash_table_lookup(Ahash, Afirst));

  va_start(Largs, Afirst);
  while (*Lbuf++) {
    if (!(Lcur = va_arg(Largs, gchar *))) break;
    
    Lname = g_strdup_printf("%s_isotodisabled%d", Abasename, Lnbr++);
    g_hash_table_insert(Ahash, Lname, g_hash_table_lookup(Ahash, Lcur));
  }

  va_end(Largs);
}

/* objets a cacher lorsque l'on selectionne une image iso en tant que source ou destination */
void prepare_disable_when_notcdrw(GHashTable *Ahash, gchar *Abasename, const gchar *Afirst, ...)
{
  va_list Largs;
  gchar *Lbuf = (gchar *) Afirst;
  gint Lnbr = 0;
  gchar *Lname = g_strdup_printf("%s_notcdrwtodisabled%d", Abasename, Lnbr++);
  gchar *Lcur;

  g_hash_table_insert(Ahash, Lname, g_hash_table_lookup(Ahash, Afirst));

  va_start(Largs, Afirst);
  while (*Lbuf++) {
    if (!(Lcur = va_arg(Largs, gchar *))) break;
    
    Lname = g_strdup_printf("%s_notcdrwtodisabled%d", Abasename, Lnbr++);
    g_hash_table_insert(Ahash, Lname, g_hash_table_lookup(Ahash, Lcur));
  }

  va_end(Largs);
} 


/*void prepare_combobox_graveur(GtkComboBox *Acombobox, GHashTable *Ahash)*/
void prepare_combobox_graveur(GladeXML *Axml, GHashTable *Ahash, gchar *Abasename)
{
  GtkComboBox *Lcombobox = GTK_COMBO_BOX(glade_to_hashv(Axml, Ahash, "%scombo", Abasename));
  if (GTK_IS_COMBO_BOX(Lcombobox)) {
    GtkListStore *Lmodel = gtk_list_store_new(4, G_TYPE_STRING, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_INT);
    GtkCellRenderer *Lcellrender;
    GtkWidget *Lbtniso = sc_glade_xml_get_widgetv(Axml, "%sbtn", Abasename);
 
    gtk_combo_box_set_model(Lcombobox, GTK_TREE_MODEL(Lmodel));
    Lcellrender = GTK_CELL_RENDERER(gtk_cell_renderer_pixbuf_new());
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(Lcombobox), Lcellrender, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(Lcombobox), Lcellrender,
      "pixbuf", 1, NULL);                    
    Lcellrender = GTK_CELL_RENDERER(gtk_cell_renderer_text_new());
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(Lcombobox), Lcellrender, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(Lcombobox), Lcellrender,
      "text", 2, NULL);

    g_signal_connect(G_OBJECT(Lcombobox), "changed", G_CALLBACK(on_selectgraveur), Ahash);
      /* il y a peutetre un champ "image iso" associe a ce combo graveur */

    if (GTK_IS_BUTTON(Lbtniso)) {
      glade_to_hashv(Axml, Ahash, "%sbtnvalue", Abasename);
      g_signal_connect(G_OBJECT(Lbtniso), "clicked", G_CALLBACK(gtk_file_sel), Ahash);
    }
  }
}

#if 0
void prepare_properties_mediatreeview(GtkTreeView *Atreeview)
{
  GtkListStore *Lmodel = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
  GtkCellRenderer *Lcellrender;
  GtkTreeViewColumn *Lcell;

  gtk_tree_view_set_model(Atreeview, GTK_TREE_MODEL(Lmodel));

  /* creation colonnes */
  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(("Label for Audio media"), Lcellrender, "text", 0, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(("Label for Data media"), Lcellrender, "text", 1, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);
}
#endif

void prepare_properties_devicestreeview(GtkTreeView *Atreeview)
{
  GtkListStore *Lmodel = gtk_list_store_new(5, G_TYPE_INT, GDK_TYPE_PIXBUF, G_TYPE_STRING,
                G_TYPE_STRING, G_TYPE_STRING);
  GtkCellRenderer *Lcellrender;
  GtkTreeViewColumn *Lcell;

  gtk_tree_view_set_model(Atreeview, GTK_TREE_MODEL(Lmodel));

  /* creation colonnes */
  Lcellrender = gtk_cell_renderer_pixbuf_new();
  Lcell = gtk_tree_view_column_new_with_attributes("", Lcellrender, "pixbuf", 1, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Location"), Lcellrender, "text", 2, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Type"), Lcellrender, "text", 3, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Name"), Lcellrender, "text", 4, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeview), Lcell);

}

void prepare_listeaudio(GtkTreeView *Atreeaudio)
{
  GtkTreeSelection *Lselection = gtk_tree_view_get_selection(GTK_TREE_VIEW(Atreeaudio));
  GtkListStore *Lmodel = gtk_list_store_new(6, G_TYPE_INT, GDK_TYPE_PIXBUF, G_TYPE_STRING,
                        G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT);
  GtkCellRenderer *Lcellrender;
  GtkTreeViewColumn *Lcell;

  gtk_tree_selection_set_mode(Lselection, GTK_SELECTION_MULTIPLE);

  /* creation colonnes */
  Lcellrender = gtk_cell_renderer_pixbuf_new();
  Lcell = gtk_tree_view_column_new_with_attributes("", Lcellrender, "pixbuf", 1, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeaudio), Lcell);
	
  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Track"), Lcellrender, "text", 2, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeaudio), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Length"), Lcellrender, "text", 3, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeaudio), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Location"), Lcellrender, "text", 4, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreeaudio), Lcell);

  gtk_tree_view_set_model(Atreeaudio, GTK_TREE_MODEL(Lmodel));
}

void prepare_listedata(GtkTreeView *Atreedata)
{
  GtkTreeSelection *Lselection = gtk_tree_view_get_selection(GTK_TREE_VIEW(Atreedata));
  GtkTreeStore *Lmodel = gtk_tree_store_new(6, G_TYPE_INT, GDK_TYPE_PIXBUF, G_TYPE_STRING,
                                G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT);
  GtkTreeIter Liter;
  GtkCellRenderer *Lcellrender;
  GtkTreeViewColumn *Lcell;

  gtk_tree_selection_set_mode(Lselection, GTK_SELECTION_MULTIPLE);
  gtk_tree_view_set_model(Atreedata, GTK_TREE_MODEL(Lmodel));

  /* creation colonnes */
  Lcellrender = gtk_cell_renderer_pixbuf_new();
  Lcell = gtk_tree_view_column_new_with_attributes("", Lcellrender, "pixbuf", 1, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreedata), Lcell);
	
  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Name"), Lcellrender, "text", 2, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreedata), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Size"), Lcellrender, "text", 3, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreedata), Lcell);

  Lcellrender = gtk_cell_renderer_text_new();
  Lcell = gtk_tree_view_column_new_with_attributes(_("Location"), Lcellrender, "text", 4, NULL);
  gtk_tree_view_append_column(GTK_TREE_VIEW(Atreedata), Lcell);

  /* icone de base dans la liste des fichiers */
  gtk_tree_store_append(GTK_TREE_STORE(Lmodel), &Liter, NULL);
  gtk_tree_store_set(Lmodel, &Liter, 0, TYPE_CD, 1, GCDpetiteIcone, 2, _("New CD"), 3, "", 4, "", 5, 0, -1);
}

/* fenetre proprietes */
GHashTable *create_dialog_proprietes (GtkWidget *Aparent)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/dialog_properties.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkToggleButton *Ltoggleoption;
  GtkEntry *Ldirtmpvalue;
  GtkTreeView *Ltreeview;
  GtkWidget *Ldialog;
  GtkButton *Lbtn;
  GHashTable *Lhash = _hash();

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  Ldialog = glade_xml_get_widget(Lxml, "dialog_properties");
  gtk_window_set_transient_for(GTK_WINDOW(Ldialog), GTK_WINDOW(Aparent));
  g_hash_table_insert(Lhash, "window", Ldialog);

  /** onglet "General" **/
  
  /* overburn actif ? */
  Ltoggleoption = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "overburn"));
  gtk_toggle_button_set_active(Ltoggleoption, conf_get_boolean("overburn"));

  /* effacer les cdrw en mode fast ? */
  Ltoggleoption = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "fastblank"));
  gtk_toggle_button_set_active(Ltoggleoption, conf_get_boolean("fastblank"));

  /* ejecter le cdr apres l'operation ? */
  Ltoggleoption = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "eject"));
  gtk_toggle_button_set_active(Ltoggleoption, conf_get_boolean("eject"));

  /* fonctions etendues ? */
#if 0  
  Ltoggleoption = GTK_TOGGLE_BUTTON(glade_to_hash(Lxml, Lhash, "extended"));
  gtk_toggle_button_set_active(Ltoggleoption, conf_get_boolean("extended"));
#endif

  /* repertoire temporraire */
  Ldirtmpvalue = GTK_ENTRY(glade_to_hash(Lxml, Lhash, "dirtmpvalue"));
  gtk_entry_set_text(Ldirtmpvalue, conf_get_string("tmpdir"));

  /** onglet "Format des medias" **/
#if 0
  Ltreeview = GTK_TREE_VIEW(glade_to_hash(Lxml, Lhash, "medialist"));
  prepare_properties_mediatreeview(Ltreeview);
  remplirelistemedia(Ltreeview);

  Lbtn = GTK_BUTTON(glade_xml_get_widget(Lxml, "addmediaformat"));
  g_signal_connect(G_OBJECT(Lbtn), "clicked", G_CALLBACK(on_addmediaformat), Lhash);
#endif


  /** onglet "Programmes externes" **/
  glade_to_hash(Lxml, Lhash, "cdrecord");
  glade_to_hash(Lxml, Lhash, "cdrecordlbl");
  glade_to_hash(Lxml, Lhash, "cdrecordpara");
  
  glade_to_hash(Lxml, Lhash, "mkisofs");
  glade_to_hash(Lxml, Lhash, "mkisofslbl");
  glade_to_hash(Lxml, Lhash, "mkisofspara");
  
  glade_to_hash(Lxml, Lhash, "readcd");
  glade_to_hash(Lxml, Lhash, "readcdlbl");
  glade_to_hash(Lxml, Lhash, "readcdpara");

  glade_to_hash(Lxml, Lhash, "sox");
  glade_to_hash(Lxml, Lhash, "soxlbl");
  glade_to_hash(Lxml, Lhash, "soxpara");

  /** onglet "Lecteurs" **/
  Ltreeview = GTK_TREE_VIEW(glade_to_hash(Lxml, Lhash, "periphdata"));
  prepare_properties_devicestreeview(Ltreeview);

  g_hash_table_insert(Lhash, "topwindow", Aparent);
  
  maj_proprietes_prog(Lhash);
  remplirelistegraveur(Ltreeview);

  Lbtn = GTK_BUTTON(glade_xml_get_widget(Lxml, "dirtmp"));
  g_signal_connect(G_OBJECT(Lbtn), "clicked", G_CALLBACK(gtk_file_sel), Lhash);

  Lbtn = GTK_BUTTON(glade_xml_get_widget(Lxml, "scanprog"));
  g_signal_connect(G_OBJECT(Lbtn), "clicked", G_CALLBACK(chercheprog), Lhash);

  Lbtn = GTK_BUTTON(glade_xml_get_widget(Lxml, "scandevice"));
  g_signal_connect(G_OBJECT(Lbtn), "clicked", G_CALLBACK(cherchelecteur), Lhash);
  
  return Lhash;
}

/* premiere utilisation de graveman, bienvenue ! */
void welcome_to_graveman(void)
{
  gchar *Ltemplate = PACKAGE_DATA_DIR "/" PACKAGE "/dialog_welcome.glade";
  GladeXML *Lxml = glade_xml_new(Ltemplate, NULL,NULL);
  GtkWidget *Ldialog;

  if (!Lxml) {
    g_error("Cannot load '%s': %s\n", Ltemplate, g_strerror(errno));
  }

  Ldialog = glade_xml_get_widget(Lxml, "dialog_welcome"); 

  gtk_dialog_run(GTK_DIALOG(Ldialog));
  gtk_widget_destroy(Ldialog);

  g_free(Lxml);
}

/* mise a jour d'une bar indicant le remplissage, passage en rouge si le cd est plein */
void switch_pbar_status(GtkProgressBar *Apbar, guint32 Amaxlen, guint32 Acurlen, Ttypemajpbar Aupdatetext) {
  gdouble Lpremp = (1.0/Amaxlen)*Acurlen;
 
  if (Lpremp>1) { 
    GdkColor Lcolor;
    gdk_color_parse ("red", &Lcolor);
    Lpremp = 1;

    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_NORMAL, &Lcolor);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_ACTIVE, &Lcolor);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_PRELIGHT, &Lcolor);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_SELECTED, &Lcolor);
  } else {
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_NORMAL, NULL);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_ACTIVE, NULL);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_PRELIGHT, NULL);
    gtk_widget_modify_bg (GTK_WIDGET(Apbar), GTK_STATE_SELECTED, NULL);
  }
  gtk_progress_bar_set_fraction(Apbar, Lpremp);

  if (Aupdatetext != PB_NONE) {
    gchar *Ltmp = Aupdatetext == PB_UPDATE_AUDIO ? format_length(Acurlen) : format_size(Acurlen);
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(Apbar), Ltmp);
    g_free(Ltmp);
  }
}

/* effacer un cd reinscriptible */
void show_erasecdrwwindow(GHashTable *Ahash)
{
  GtkWidget *Lwindow1 = g_hash_table_lookup(Ahash, "window");
  GladeXML *Lxmlencours = create_window_encours(Lwindow1);
  gint Lcont = 2;
  gint Lpid;
  gboolean Loperationstatus = FALSE;
  gboolean Labort = FALSE;
  GtkWidget *Lprogressbar;
  GtkLabel *Llabel;
  GtkWidget *Lcancel;
  GtkWidget *Lwin;
  GHashTable *Lerasecdhash = _hash();
  GError *Lerror = NULL;
  GtkWidget *Lstatusbox = NULL;

  Lwin = glade_xml_get_widget(Lxmlencours, "window_inprogress"); 
  Llabel = GTK_LABEL(glade_xml_get_widget(Lxmlencours, "labelava"));
  gtk_label_set_text(Llabel, _("Erasing CD-RW in progress, please wait..."));

  
  Lprogressbar = glade_xml_get_widget(Lxmlencours, "progress");
  g_hash_table_insert(Lerasecdhash, "cont", &Lcont);
  g_hash_table_insert(Lerasecdhash, "pid", &Lpid);
  g_hash_table_insert(Lerasecdhash, "gabort", &Labort);
  g_hash_table_insert(Lerasecdhash, "gerror", &Lerror);
  g_hash_table_insert(Lerasecdhash, "operationstatus", &Loperationstatus);
  g_hash_table_insert(Lerasecdhash, "labelava", Llabel);
  g_hash_table_insert(Lerasecdhash, "progress", Lprogressbar);
  g_hash_table_insert(Lerasecdhash, "dstothercombo", g_hash_table_lookup(Ahash, "dstothercombo"));

  /* bouton annuler */
  Lcancel = glade_xml_get_widget(Lxmlencours, "cancelbtn");
  g_signal_connect(G_OBJECT(Lcancel), "clicked", G_CALLBACK(abort_encours), (GtkWidget *)Lerasecdhash);

  gtk_widget_show(Lwin);
  g_timeout_add(500, encours_callback, Lerasecdhash);

  /* operation en elle meme */
  perform_erase_cdrw(Lerasecdhash, &Lerror);
  
  if (Labort) {
    Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
                                     GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK,
                                     _("Operation aborted by user !"));
  } else if (Lerror) {
    Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
                      GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK,
                      Lerror->message);
  } else {
     Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
               GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK,
               _("Operation successful"));
  }
  gtk_dialog_run(GTK_DIALOG(Lstatusbox));
  gtk_widget_destroy(Lstatusbox);
  
  gtk_widget_destroy(Lwin);
  g_hash_table_destroy(Lerasecdhash);

  if (Lerror) g_error_free(Lerror);
}

/* cloturer un cd */
void show_fixcdwindow(GHashTable *Ahash)
{
  GtkWidget *Lwindow1 = g_hash_table_lookup(Ahash, "window");
  GladeXML *Lxmlencours = create_window_encours(Lwindow1);
  gint Lcont = 2;
  gint Lpid;
  gboolean Loperationstatus = FALSE;
  gboolean Labort = FALSE;
  GtkWidget *Lprogressbar;
  GtkLabel *Llabel;
  GtkWidget *Lcancel;
  GtkWidget *Lwin;
  GHashTable *Lfixcdhash = _hash();
  GError *Lerror = NULL;
  GtkWidget *Lstatusbox = NULL;

  Lwin = glade_xml_get_widget(Lxmlencours, "window_inprogress"); 
  Llabel = GTK_LABEL(glade_xml_get_widget(Lxmlencours, "labelava"));
  gtk_label_set_text(Llabel, _("Fixating CD-R in progress, please wait..."));

  
  Lprogressbar = glade_xml_get_widget(Lxmlencours, "progress");
  g_hash_table_insert(Lfixcdhash, "cont", &Lcont);
  g_hash_table_insert(Lfixcdhash, "pid", &Lpid);
  g_hash_table_insert(Lfixcdhash, "gabort", &Labort);
  g_hash_table_insert(Lfixcdhash, "gerror", &Lerror);
  g_hash_table_insert(Lfixcdhash, "operationstatus", &Loperationstatus);
  g_hash_table_insert(Lfixcdhash, "labelava", Llabel);
  g_hash_table_insert(Lfixcdhash, "progress", Lprogressbar);
  g_hash_table_insert(Lfixcdhash, "dstothercombo", g_hash_table_lookup(Ahash, "dstothercombo"));

  /* bouton annuler */
  Lcancel = glade_xml_get_widget(Lxmlencours, "cancelbtn");
  g_signal_connect(G_OBJECT(Lcancel), "clicked", G_CALLBACK(abort_encours), (GtkWidget *)Lfixcdhash);

  gtk_widget_show(Lwin);
  g_timeout_add(500, encours_callback, Lfixcdhash);

  /* operation en elle meme */
  perform_fix_cd(Lfixcdhash, &Lerror);
  
  if (Labort) {
    Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
                                     GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK,
                                     _("Operation aborted by user !"));
  } else if (Lerror) {
    Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
                      GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK,
                      Lerror->message);
  } else {
     Lstatusbox = gtk_message_dialog_new(GTK_WINDOW(Lwin),
               GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK,
               _("Operation successful"));
  }
  gtk_dialog_run(GTK_DIALOG(Lstatusbox));
  gtk_widget_destroy(Lstatusbox);
  
  gtk_widget_destroy(Lwin);
  g_hash_table_destroy(Lfixcdhash);

  if (Lerror) g_error_free(Lerror);
}

/*
 * vim:et:ts=8:sts=2:sw=2
 */
